<?php
// $Id: revisiontags_handler_field_tag.inc,v 1.1.2.1 2010/03/03 14:09:13 franskuipers Exp $
/**
 * @file revisiontags_handler_field_tag.inc
 * Contains the basic 'revisiontag' field handler.
 */

/**
 * Field handler to provide simple renderer that allows linking to a node.
 */
class revisiontags_handler_field_tag extends views_handler_field {
  /**
   * Constructor to provide additional field to add.
   */
  function construct() {
    parent::construct();
    $this->additional_fields['nid'] = 'nid';
//    $this->additional_fields['vid'] = array('table' => 'node_revisions', 'field' => 'vid');
    $this->additional_fields['vid'] = 'vid';
  }

  function access() {
    return user_access('view tagged revisions') || user_access('tag revisions') || user_access('administer nodes');
  }

  function option_definition() {
    $options = parent::option_definition();
    $options['link_to_node'] = array('default' => FALSE);
    return $options;
  }

  /**
   * Provide link to node option
   */
  function options_form(&$form, &$form_state) {
    parent::options_form($form, $form_state);
    $form['link_to_node'] = array(
      '#title' => t('Link this field to its node'),
      '#type' => 'checkbox',
      '#default_value' => !empty($this->options['link_to_node']),
    );
  }

  /**
   * Render whatever the data is as a link to the node.
   *
   * Data should be made XSS safe prior to calling this function.
   */
  function render($values) {
    // ensure user has access to view this node.
    $node = new stdClass();
    $node->nid = $values->{$this->aliases['nid']};
    $node->vid = $values->{$this->aliases['vid']};
    $node->tag = check_plain($values->{$this->field_alias});

    if (user_access('tag revisions') || user_access('administer nodes')) {
    // @TODO  title="Edit the revision tag"
      return l(t($node->tag), "node/$node->nid/revision_tags/$node->vid/edit", array('query' => drupal_get_destination(), 'title' => 'Edit the revisiontag'));
    }
    else
      return t($node->tag);
  }
}
